Write-Host "You will be prompted to enter the credentials for CONTOSO\SP_WebApps."
Write-Host "The password for the account is Pa`$`$w0rd."
Write-Host "Press ENTER to continue"
$temp = Read-Host

$cred = Get-Credential "CONTOSO\SP_WebApps"

Write-Host "Registering managed account: CONTOSO\SP_WebApps"
New-SPManagedAccount -Credential $cred

Write-Host
Write-Host "Creating web application: teams.contoso.com"

New-SPWebApplication -Name "Contoso Team Collaboration" -Port 80 -HostHeader "teams.contoso.com" -URL "http://teams.contoso.com:80" -ApplicationPool "SharePoint Web Applications" -ApplicationPoolAccount (Get-SPManagedAccount "CONTOSO\SP_WebApps") -DatabaseName "SharePoint_Content_Teams"

Write-Host "Creating site collection and top-level site: http://teams.contoso.com/"

New-SPSite -Url "http://teams.contoso.com" -ContentDatabase SharePoint_Content_Teams -Name "Contoso Collaboration" -Description "Contoso Business Unit, Department, Team and Project Collaboration Sites" -OwnerAlias "CONTOSO\SP_Admin" -Template "STS#0"

Write-Host "Creating managed path: depts"

New-SPManagedPath "depts" -WebApplication "http://teams.contoso.com"

Write-Host "Creating DNS A record: teams.contoso.com - 10.0.0.21"

DnsCmd CONTOSO-DC /RecordAdd contoso.com teams A 10.0.0.21

Write-Host "Setup complete."
