@echo off
cls

:: Post-DCPROMO Configuration of CONTOSO-DC
:: by Dan Holme
::
:: The script is provided AS-IS
:: with no warranty expressed or implied
:: Use only in a test environment, at your own risk
::
:: (c) 2010 Intelliem, Inc.
::
:: This script may be used only as directed by the
:: Lab Environment Build Guide
:: that accompanies the 70-667 Training Kit
:: published by Microsoft Press.
:: The script may be used only in conjunction with 
:: study of the Training Kit
::
:: Contact dan.holme@intelliem.com for more information
::

SET DebugLog=YES
SET AllowChoice=NO
SET CourseID=70667TK
SET MachineRole=%COMPUTERNAME%

SET Connection_Name=Local Area Connection
SET IP_DNS=10.0.0.11

echo Configure %MachineRole%
echo =============================================================================
echo.
echo Requirements:
echo Script must be executed by the local Administrator 
echo or with the Run As Administrator option
echo.

:: CHOICE /T 10 /D Y /M "Are all requirements met? Do you want to continue"
:: IF ERRORLEVEL 2 GOTO :EOF
:: echo.

IF x%CourseID%x==xx SET /p CourseID=Course ID: 
SET VMNAME=%CourseID%-%MachineRole%
IF %DebugLog%==YES SET LOGFILE=C:\%VMNAME%-SetupLog.txt
IF NOT %DebugLog%==YES SET LOGFILE=nul:
echo ======================================== >> %LOGFILE%
echo SCRIPT: %0 >> %LOGFILE%
echo DATE:   %DATE% %TIME% >> %LOGFILE%
echo USER:   %USERNAME% >> %LOGFILE%
echo ======================================== >> %LOGFILE%

netsh dnsclient set dnsservers name="%Connection_Name%" source=static address=%IP_DNS% register=primary validate=no 1> nul:
IF %ERRORLEVEL%==0 echo Set primary DNS server to %IP_DNS% & echo Set primary DNS server to %IP_DNS% >> %LOGFILE%

reg add HKLM\SYSTEM\CurrentControlSet\Services\NTDS\Parameters /v "Allow Replication with Divergent and Corrupt Partner" /t REG_DWORD /d 1 /f 1> nul:
IF %ERRORLEVEL%==0 echo Allow Replication with Divergent and Corrupt Partner & echo Allow Replication with Divergent and Corrupt Partner >> %LOGFILE%

reg add HKLM\SYSTEM\CurrentControlSet\Services\Netlogon\Parameters /v "RefusePasswordChange" /t REG_DWORD /d 1 /f 1> nul:
IF %ERRORLEVEL%==0 echo Refuse computer password resets & echo Refuse computer password resets >> %LOGFILE%

echo.
echo Script will restart the computer to complete the process

:Review
echo =============================================================================
echo COMPLETE
:: Reset ERRORLEVEL to 0
verify >nul
IF %AllowChoice%==YES CHOICE /T 10 /D N /M "Pause to review"
IF ERRORLEVEL 2 GOTO End
IF %AllowChoice%==NO GOTO End
pause

:End
echo.
pause
echo Restarting computer...
echo Restart computer >> %LOGFILE%
shutdown /t 0 /r

GOTO :EOF