' Set the screen resolution to 1024x768
' by Dan Holme
'
' The script is provided AS-IS
' with no warranty expressed or implied
' Use only in a test environment, at your own risk
'
' (c) 2010 Intelliem, Inc.
'
' This script may be used only as directed by the
' Lab Environment Build Guide
' that accompanies the 70-667 Training Kit
' published by Microsoft Press.
' The script may be used only in conjunction with 
' study of the Training Kit
'
' Contact dan.holme@intelliem.com for more information
'

RunWithCScript_PauseForOutput = True
RunWithCScript

WScript.Echo "----------------------------------------------------------------------"
WScript.Echo "START - Change display resolution to 1024 x 768"

' Change display resolution in HKEY_CURRENT_CONFIG (&H80000005) for full installation computer
' instead of HKEY_LOCAL_MACHINE (&H80000002) for server core
' REQUIRES LOGOFF/LOGON

Set objReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\default:StdRegProv")
objReg.GetStringValue &H80000002,"HARDWARE\DEVICEMAP\VIDEO","\Device\Video0",RegValueData
' DEBUG WScript.Echo RegValueData & vbCrLf & "\Registry\Config\" & Right(RegValueData,82)
' objReg.SetDWORDValue &H80000005,RIGHT(RegValueData, 82),"Acceleration.Level",0
objReg.SetDWORDValue &H80000005,RIGHT(RegValueData, 82),"DefaultSettings.XResolution",1024
objReg.SetDWORDValue &H80000005,RIGHT(RegValueData, 82),"DefaultSettings.YResolution",768

WScript.Echo "COMPLETE - Requires logoff/logon to take effect"
WScript.Echo "----------------------------------------------------------------------"

Set colNamedArguments = WScript.Arguments.Named
If colNamedArguments.Exists("RunWithCScript_Pause") Then
    MsgBox "Script was run with WScript instead of CScript." & vbCrLf & _
           "Now pause for review of output in command prompt."
End If

WScript.Quit

' ======================================================================
' Ensure CScript Engine Is Used

Sub RunWithCScript

Dim strArg, strNamedArg, strArgs, strCmd, strEngine, i, objDebug, wshShell, strMsg
Set wshShell = CreateObject( "WScript.Shell" )

strEngine = UCase( Right( WScript.FullName, 12 ) )

If strEngine <> "\CSCRIPT.EXE" Then
    ' Throw a flag that can be used in the body of the script
    RunWithCScript_Engine = False

    ' Recreate list of arguments used to call this script
    ' This routine needs to be built to accomodate
    ' arguments with spaces and named arguments
    strArgs = ""
    For each strArg in WScript.Arguments.Unnamed
        If instr(strArg,Chr(34)) > 0 then
            strMsg = WScript.ScriptName & vbCrLf & _
                "WARNING: The script has not been tested " & _
                " for arguments that contain quotes. Exiting."
            MsgBox strMsg
            WScript.Quit(501)
        End If
        If instr(strArg," ") > 0 then
            strArg = Chr(34) & strArg & Chr(34)
        End If
        strArgs = strArgs & " " & strArg
    Next

    For each strNamedArg in WScript.Arguments.Named
	strArg = WScript.Arguments.Named(strNamedArg)
        If instr(strArg,Chr(34)) > 0 then
            strMsg = WScript.ScriptName & vbCrLf & _
                "WARNING: The script has not been tested " & _
                " for arguments that contain quotes. Exiting."
            MsgBox strMsg
            WScript.Quit(501)
        End If
        If instr(strArg," ") > 0 then
            strArg = Chr(34) & strArg & Chr(34)
        End If
        strArgs = strArgs & " /" & strNamedArg & ":" & strArg
    Next

    ' Create the command line to run this script with CSCRIPT
    strCmd = "CSCRIPT.EXE //nologo """ & WScript.ScriptFullName & """" & strArgs

    ' Run the script
    ' This could be more elegant using WSHShell.Exec but then there is no output

    If RunWithCScript_PauseForOutput Then
        strCmd = strCmd & " /RunWithCScript_Pause"
    End If

    wshShell.Run strCmd, 1, true
    WScript.Quit (0)

End If

End Sub
